%------ Lez TTR 06 giugno 2012 ------
% Ripasso
clc
clear all
close all
load 'irisSet.mat'; % In l ho le etichette, in X i dati (dim x numero_punti);


num_iter = 100;
K=15;
%% Crossvalidazione KNN dati normali
[confusion_exp]=Cross_valida(X,l,num_iter,K);
confusion = mean(confusion_exp,3);
accu = sum(diag(confusion))/sum(confusion(:));
% manca il calcolo della precision e della recall...

%% Crossvalidazione KNN +PCA
[d,N] = size(X);
% 1: media
u = mean(X,2);
% 2: centering
h = ones(1,N);
B = X-u*h;
% 3: covariance matrix
C = 1/N * B*B';
% 4: eigenvalues/eigenvectors
[V,D] = eig(C);
% 5: sort eigenvalues
D=diag(D);
[D,ind]=sort(D,'descend');
V = V(:,ind);
% 6: transform matrix
A = V(:,1:2);
% 6: transformation
Y = A'*B;

[confusionPCA_exp]=Cross_valida(Y,l,num_iter,K);
confusionPCA = mean(confusionPCA_exp,3);
accuPCA = sum(diag(confusionPCA))/sum(confusionPCA(:));

fprintf('Accu dati normali=%2.3f\n',accu)
fprintf('Accu dati PCA=%2.3f\n',accuPCA)


