function [confusion]=Cross_valida(X,l,num_iter,K)



% Dimensionalita' dei dati
[dim, num_punti] = size(X);

% Numero di classi e loro cardinalita'
C = unique(l);
num_classi = length(C);
for c=1:num_classi
    ind{c}= find(l==C(c));
    car(c)=length(ind{c});
end

for iter=1:num_iter
% suddivisione train test;
global_train_ind =[];
global_ltr = [];
global_test_ind = [];
global_lte = [];

for c=1:num_classi
    ran{c}= randperm(car(c)); 
    train_ind{c}= ind{c}(ran{c}(1:floor(end/2)));
    test_ind{c}= ind{c}(ran{c}(floor(end/2)+1:end));
    global_train_ind = [global_train_ind; train_ind{c}];
    global_test_ind = [global_test_ind; test_ind{c}];
end

global_ltr = l(global_train_ind);
global_lte = l(global_test_ind);


confusion(:,:,iter) = zeros(max(C));
for i=1:length(global_lte)
[res]=MYknn(X(:,global_test_ind(i)),X(:,global_train_ind),global_ltr,K);
confusion(res,global_lte(i),iter)= confusion(res,global_lte(i),iter)+1;
end

end



